# DFTK-based calculator for ASE

| **Documentation**                                       | **Build Status**      |  **Installation**         |
|:------------------------------------------------------- |:--------------------- |:------------------------- |
| [![][docs-img]][docs-url] [![][gitter-img]][gitter-url] | [![][ci-img]][ci-url] | [![][pypi-img]][pypi-url] |

[docs-img]: https://img.shields.io/badge/docs-latest-blue.svg
[docs-url]: https://github.com/mfherbst/asedftk/blob/master/docs/asedftk.md

[gitter-img]: https://badges.gitter.im/DFTK-jl/community.svg
[gitter-url]: https://gitter.im/DFTK-jl/community

[ci-img]: https://github.com/mfherbst/asedftk/workflows/CI/badge.svg?branch=master&event=push
[ci-url]: https://github.com/mfherbst/asedftk/actions

[pypi-img]: https://img.shields.io/pypi/v/asedftk
[pypi-url]: https://pypi.org/project/asedftk

Small wrapper around the
[**density-functional toolkit (DFTK)**](https://dftk.org)
to provide a
[calculator interface](https://wiki.fysik.dtu.dk/ase/ase/calculators/calculators.html)
compatible with [ASE](https://wiki.fysik.dtu.dk/ase/index.html),
the atomistic simulation environment.

[DFTK](https://dftk.org) is a small library of Julia algorithms
for developing plane-wave-based density-functional theory methods.
Albeit only a good year of development it already has a [sizeable feature set](https://docs.dftk.org/dev/#package-features)
and a performance on the same order as established packages in the field.
See [dftk.org](https://dftk.org) and the [DFTK documentation](https://juliamolsim.github.io/DFTK.jl/dev/) for more details.

## Installation
See the [asedftk instructions](https://github.com/mfherbst/asedftk/blob/master/docs/asedftk.md).

## Basic usage
`asedftk.DFTK` is basically a class wrapping around DFTK and making it an
[ASE calculator](https://wiki.fysik.dtu.dk/ase/ase/calculators/calculators.html).
Just use it like any other calculator class. For example:
```python
from asedftk import DFTK
from ase.build import bulk

atoms = bulk("Si")
atoms.calc = DFTK()
print(atoms.get_potential_energy())
```

More details can be found in the [asedftk documentation](https://github.com/mfherbst/asedftk/blob/master/docs/asedftk.md).

using Test
using PyCall
using DFTK
bulk = pyimport("ase.build").bulk
include("calculator.jl")


py"""
import ase
cell = [[3.21, 0.0, 0.0], [-1.605, 2.7799415461480477, 0.0], [0.0, 0.0, 5.21304]]
positions = [[0.0, 0.0, 0.0], [0.0, 1.85329, 2.60652]]
atoms = ase.Atoms(symbols='Mg2', pbc=True, cell=cell, positions=positions)
"""

@testset "Basic LDA basis construction" begin
    calc = asedftk.DFTK(;xc="LDA", kpts=[1, 2, 3], ecut=300)
    calc.atoms = py"atoms"
    basis = calc.get_dftk_basis()

    lattice = basis.model.lattice
    @test lattice[:, 1] ≈ DFTK.units.Ǎ * [3.21, 0.0, 0.0]
    @test lattice[:, 2] ≈ DFTK.units.Ǎ * [-1.605, 2.7799415461480477, 0.0]
    @test lattice[:, 3] ≈ DFTK.units.Ǎ * [0.0, 0.0, 5.21304]

    atoms = basis.model.atoms
    @test length(atoms) == 1
    @test all(at isa ElementPsp for (at, positions) in atoms)
    @test atoms[1][1].symbol == :Mg
    @test atoms[1][2][1] ≈ [0, 0, 0]
    @test atoms[1][2][2] ≈ [1/3, 2/3, 1/2] atol=1e-5
    @test atoms[1][1].psp.identifier == "hgh/lda/mg-q2.hgh"
    @test atoms[1][1].psp.Zion == 2

    @test basis.model.temperature == 0.0
    @test basis.model.smearing isa DFTK.Smearing.None
    @test basis.model.spin_polarization == :none

    xcterm = [tt for tt in basis.model.term_types if tt isa Xc][1]
    @test length(xcterm.functionals) == 1
    @test xcterm.functionals[1].identifier == :lda_xc_teter93

    @test length(basis.kpoints) == 4
    @test basis.Ecut ≈ 300 * DFTK.units.eV atol=1e-8
end

@testset "PBE semicore basis construction" begin
    calc = asedftk.DFTK(;xc="PBE", kpts=0.3, smearing=("Gaussian", 10),
                        pps="hgh.k")  # semicore psps
    calc.atoms = py"atoms"
    basis = calc.get_dftk_basis()

    atoms = basis.model.atoms
    @test length(atoms) == 1
    @test length(atoms) == 1
    @test all(at isa ElementPsp for (at, positions) in atoms)
    @test atoms[1][1].psp.identifier == "hgh/pbe/mg-q10.hgh"
    @test atoms[1][1].psp.Zion == 10

    @test basis.model.temperature ≈ 10 * DFTK.units.eV atol=1e-8
    @test basis.model.smearing isa DFTK.Smearing.Gaussian
    @test basis.model.spin_polarization == :none

    xcterm = [tt for tt in basis.model.term_types if tt isa Xc][1]
    @test length(xcterm.functionals) == 2
    @test xcterm.functionals[1].identifier == :gga_x_pbe
    @test xcterm.functionals[2].identifier == :gga_c_pbe

    kgrid = DFTK.kgrid_size_from_minimal_spacing(basis.model.lattice,
                                                 0.3 / DFTK.units.Ǎ)
    kcoords, ksymops = bzmesh_ir_wedge(kgrid, basis.model.lattice, basis.model.atoms)
    @test kcoords ≈ [kpt.coordinate for kpt in basis.kpoints]
end

@testset "Custom functional construction" begin
    kpts = [(0, 0, 0), (0.5, 0.7, 0.3)]
    calc = asedftk.DFTK(;xc="PBE", kpts=kpts, smearing=("Fermi-Dirac", 5))
    calc.atoms = py"atoms"
    basis = calc.get_dftk_basis()

    @test basis.model.temperature ≈ 5 * DFTK.units.eV atol=1e-8
    @test basis.model.smearing isa DFTK.Smearing.FermiDirac
    @test basis.model.spin_polarization == :none

    xcterm = [tt for tt in basis.model.term_types if tt isa Xc][1]
    @test length(xcterm.functionals) == 2
    @test xcterm.functionals[1].identifier == :gga_x_pbe
    @test xcterm.functionals[2].identifier == :gga_c_pbe

    @test length(basis.kpoints) == 2
    @test Float64.(basis.kpoints[1].coordinate) ≈ [kpts[1]...]
    @test Float64.(basis.kpoints[2].coordinate) ≈ [kpts[2]...]
end

@testset "Test kpoint options" begin
    kpointoptions = [
        (ase=0.5,                length=18, kpt1=[0.0, 0.0, 0.0], kpt2=[ 1/5, 0.0, 0.0]),
        (ase=[2, 3, 4],          length=12, kpt1=[0.0, 0.0, 0.0], kpt2=[-0.5, 0.0, 0.0]),
        (ase=[2, 3, 4, "gamma"], length=9,  kpt1=[1/4, 1/6, 0.0], kpt2=[-1/4, 1/6, 0.0]),
        (ase=[(0, 0.2, 0), (0.5, 0.2, 0.3)], length=2,
         kpt1=[0, 0.2, 0], kpt2=[0.5, 0.2, 0.3]),
    ]

    for params in kpointoptions
        calc = asedftk.DFTK(;kpts=params.ase)
        calc.atoms = py"atoms"
        basis = calc.get_dftk_basis()
        @test length(basis.kpoints) == params.length
        @test Float64.(basis.kpoints[1].coordinate) ≈ params.kpt1
        @test Float64.(basis.kpoints[2].coordinate) ≈ params.kpt2
    end
end

@testset "Test smearing options" begin
    smearingoptions = [
        (ase=("Fermi-Dirac", 10), temperature=10 * DFTK.units.eV,
         smearing=DFTK.Smearing.FermiDirac),
        (ase=("Gaussian", 5), temperature=5 * DFTK.units.eV,
         smearing=DFTK.Smearing.Gaussian),
        (ase=("Methfessel-Paxton", 5, 0), temperature=5 * DFTK.units.eV,
         smearing=DFTK.Smearing.Gaussian),
        (ase=("Methfessel-Paxton", 5, 1), temperature=5 * DFTK.units.eV,
         smearing=DFTK.Smearing.MethfesselPaxton1),
        (ase=("Methfessel-Paxton", 5, 2), temperature=5 * DFTK.units.eV,
         smearing=DFTK.Smearing.MethfesselPaxton2),
    ]

    for params in smearingoptions
        calc = asedftk.DFTK(;smearing=params.ase)
        calc.atoms = py"atoms"
        model = calc.get_dftk_model()
        @test model.smearing isa params.smearing
        @test model.temperature ≈ params.temperature atol=1e-8
    end
end

@testset "Test mixing options" begin
    mixingoptions = [
        (ase=("SimpleMixing"), mixing=SimpleMixing, α=1.0),
        (ase=("SimpleMixing", 0.4), mixing=SimpleMixing, α=0.4),
        (ase=("KerkerMixing", 0.4, 0.7), mixing=KerkerMixing, α=0.4),
        (ase=("KerkerMixing"), mixing=KerkerMixing, α=0.8),
    ]

    for params in mixingoptions
        calc = asedftk.DFTK(;mixing=params.ase)
        calc.atoms = py"atoms"
        mixing = calc.get_dftk_mixing()
        @test mixing isa params.mixing
        @test mixing.α == params.α
    end
end

# TODO Missing checks for mandatory ASE parameters:
#      See https://wiki.fysik.dtu.dk/ase/development/calculators.html
#      and https://wiki.fysik.dtu.dk/ase/development/proposals/calculators.html
#      - charge

@testset "Silicon calculation" begin
    label = "silicon_dftk"
    ENERGY_PBE = -213.12688268374683  # eV
    FORCES_PBE = [[0.0 0.0 0.0]; [0.0 0.0 0.0]]

    silicon = bulk("Si")
    silicon.calc = asedftk.DFTK(;xc="PBE", kpts=(3, 3, 3), ecut=190, scftol=1e-4,
                                nbands=12, label=label)
    @test silicon.get_potential_energy() ≈ ENERGY_PBE atol=1e-4 rtol=1e-4
    @test silicon.get_forces() ≈ FORCES_PBE atol=1e-2
    @test length(silicon.calc.scfres.eigenvalues[1]) ≥ 12

    orig_ene = silicon.get_potential_energy()
    orig_forces = silicon.get_forces()

    # Read resultsfile again:
    @test isfile(label * ".json")
    silicon.calc = asedftk.DFTK(restart=label)

    # Check we got the old parameters and results back:
    @test silicon.calc.parameters["xc"] == "PBE"
    @test silicon.calc.parameters["kpts"] == [3, 3, 3]
    @test silicon.calc.parameters["ecut"] == 190
    @test silicon.calc.results["energy"] ≈ orig_ene
    @test silicon.calc.results["forces"] ≈ orig_forces

    # Test some invariances
    @test silicon == asedftk.DFTK.read_atoms(label)
    @test silicon == asedftk.DFTK(restart=label, label=label).get_atoms()
end

using DFTK
using JLD2
using JSON3

# DFTK
setup_threading()

a = 10.26  # Silicon lattice constant in Bohr
lattice = a / 2 * [[0 1 1.];
                   [1 0 1.];
                   [1 1 0.]]
Si = ElementPsp(:Si, psp=load_psp("hgh/lda/Si-q4"))
atoms = [Si => [ones(3)/8, -ones(3)/8]]

model = model_LDA(lattice, atoms)
basis = PlaneWaveBasis(model, 10.0; kgrid=[1, 1, 1])

callback = DFTK.ScfSaveCheckpoints("checkpointfile.jld2") ∘ DFTK.ScfDefaultCallback()
scfres = self_consistent_field(basis, tol=1e-2, callback=callback, mixing=KerkerMixing())
compute_forces_cart(scfres)

# JSON
JSON3.read(JSON3.write(Dict("a" => 1.0)))["a"]

module asedftk
using PyCall
using LinearAlgebra
import JSON
import DFTK: PlaneWaveBasis, Model, self_consistent_field, load_psp
import DFTK: load_lattice, load_atoms, ElementPsp, model_DFT, forces
import DFTK: Smearing, kgrid_size_from_minimal_spacing, Vec3, Mat3
import DFTK: KerkerMixing, SimpleMixing, scf_default_callback

ase_units = pyimport("ase.units")
ase_io = pyimport("ase.io")
calculator = pyimport("ase.calculators.calculator")

# Raise an InputError exception
inputerror(s) = pyraise(calculator.InputError(s))

# Discussion of valid parameters:
#
# - xc, kpts, smearing, nbands as in
#   https://wiki.fysik.dtu.dk/ase/development/proposals/calculators.html
# - functional: If specified, defines the precise functionals used from libxc,
#   if not autodetermined from xc parameter.
# - pps: Pseudopotential family employed. Valid are "hgh" and "hgh.k" in which
#   case the semi-core versions of the HGH pseudopotentials is used.
# - scftol: SCF convergence tolerance.
# - ecut: Kinetic energy cutoff (in eV)
#

@pydef mutable struct DFTK <: calculator.Calculator
    implemented_properties = ["energy", "forces"]

    function __init__(self; atoms=nothing, label="dftk", kwargs...)
        self.default_parameters = Dict{String,Any}(
            "xc"          => "LDA",
            "kpts"        => 0.25,
            "smearing"    => nothing,
            "nbands"      => nothing,
            "charge"      => 0.0,
            "functionals" => nothing,
            "pps"         => "hgh",
            "scftol"      => 1e-5,
            "ecut"        => 400,
            "verbose"     => false,
            "mixing"      => nothing,
        )

        calculator.Calculator.__init__(self; label=label, kwargs...)
        self.scfres = nothing   # Results of the most recent SCF run
    end

    function reset(self)
        # Reset internal state by purging all intermediates
        calculator.Calculator.reset(self)
        self.scfres = nothing
    end

    function read(self, label)
        calculator.Calculator.read(self, label)

        saved_dict = open(JSON.parse, label * ".json", "r")
        self.parameters = calculator.Parameters(saved_dict["parameters"])
        self.results = saved_dict["results"]
        @pywith pyimport("io").StringIO(saved_dict["atoms"]) as f begin
            self.atoms = ase_io.read(f, format="json")
        end

        self.scfres = nothing  # Discard any cached results
    end

    function write(self, label=self.label)
        if isnothing(self.atoms)
            pyraise(calculator.CalculatorSetupError("An Atoms object must be present " *
                                                    "in the calculator to use write"))
        end

        # Convert atoms to json
        atoms_json = ""
        @pywith pyimport("io").StringIO() as f begin
            ase_io.write(f, self.atoms.copy(), format="json")
            atoms_json = f.getvalue()
        end

        # Transpose arrays inside results, such that they are written
        # in a predictable order to disk
        results = Dict{String, Any}()
        for (key, val) in pairs(self.results)
            if val isa AbstractArray
                if ndims(val) == 2
                    results[key] = collect(eachrow(val))
                    continue
                elseif ndims(val) > 2
                    error("Arrays of dimension larger 2 not supported")
                end
            end
            results[key] = val
        end
        open(label * ".json", "w") do fp
            save_dict = Dict(
                "parameters" => self.parameters,
                "results" => results,
                "atoms" => atoms_json,
            )
            JSON.print(fp, save_dict)
        end
    end

    function set(self; kwargs...)
        changed_parameters = calculator.Calculator.set(self; kwargs...)
        if !isempty(changed_parameters)
            # Currently reset on all parameter changes
            # TODO Improve
            self.reset()
        end
    end

    function check_state(self, atoms)
        system_changes = calculator.Calculator.check_state(self, atoms)
        if "pbc" in system_changes
            # Ignore boundary conditions (we always use PBCs)
            deleteat!(system_changes, findfirst(isequal("pbc"), system_changes))
        end
        system_changes
    end

    function get_spin_polarized(self)
        if isnothing(self.scfres)
            false
        else
            self.scfres.basis.model.spin_polarization in (:full, :collinear)
        end
    end

    function get_dftk_model(self)
        inputerror_param(param) = inputerror("Unknown value to $param: " *
                                             "$(self.parameters[param])")
        if isnothing(self.atoms)
            pyraise(calculator.CalculatorSetupError("An Atoms object must be provided to " *
                                                    "perform a calculation"))
        end

        # Parse psp and DFT functional parameters
        functionals = [:lda_xc_teter93]
        if lowercase(self.parameters["xc"]) == "lda"
            psp_functional = "lda"
            functionals = [:lda_xc_teter93]
        elseif lowercase(self.parameters["xc"]) == "pbe"
            psp_functional = "pbe"
            functionals = [:gga_x_pbe, :gga_c_pbe]
        else
            inputerror_param("xc")
        end

        if !isnothing(self.parameters["functionals"])
            funs = self.parameters["functionals"]
            if funs isa AbstractArray
                functionals = Symbol.(funs)
            else
                functionals = [Symbol(funs)]
            end
        end

        if self.parameters["pps"] == "hgh"
            psp_family = "hgh"
            psp_core = :fullcore
        elseif self.parameters["pps"] == "hgh.k"
            psp_family = "hgh"
            psp_core = :semicore
        else
            inputerror_param("pps")
        end

        # Parse smearing and temperature
        temperature = 0.0
        smearing = nothing
        if !isnothing(self.parameters["smearing"])
            psmear = self.parameters["smearing"]
            if lowercase(psmear[1]) == "fermi-dirac"
                smearing = Smearing.FermiDirac()
            elseif lowercase(psmear[1]) == "gaussian"
                smearing = Smearing.Gaussian()
            elseif lowercase(psmear[1]) == "methfessel-paxton"
                smearing = Smearing.MethfesselPaxton(psmear[3])
            else
                inputerror_param("smearing")
            end
            temperature = convert(Float64, psmear[2] / ase_units.Hartree)
        end

        if self.parameters["charge"] != 0.0
            inputerror("Charged systems not supported in DFTK.")
        end

        # TODO This is the place where spin-polarization should be added
        #      once it is in DFTK.

        # Build DFTK atoms
        psploader(symbol) = load_psp(symbol, functional=psp_functional,
                                     family=psp_family, core=psp_core)
        lattice = load_lattice(self.atoms)
        atoms = [ElementPsp(element.symbol, psp=psploader(element.symbol)) => positions
                 for (element, positions) in load_atoms(self.atoms)]

        model_DFT(lattice, atoms, functionals; temperature=temperature,
                  smearing=smearing)
    end

    function get_dftk_basis(self; model=self.get_dftk_model())
        # Build kpoint mesh
        kpts = self.parameters["kpts"]
        kgrid = [1, 1, 1]
        kshift = [0, 0, 0]
        if kpts isa Number
            kgrid = kgrid_size_from_minimal_spacing(model.lattice, kpts * ase_units.Bohr)
        elseif length(kpts) == 3 && all(kpt isa Number for kpt in kpts)
            kgrid = kpts  # Just a plain MP grid
        elseif length(kpts) == 4 && all(kpt isa Number for kpt in kpts[1:3])
            kpts[4] != "gamma" && inputerror("Unknown value to kpts: $kpts")
            kshift = Int.(iseven.([2, 4, 5])) .// 2  # Shift MP grid to always contain Gamma
            kgrid = kpts[1:3]
        elseif kpts isa AbstractArray
            kgrid = nothing
            kshift = nothing
            kcoords = [Vec3(kpt...) for kpt in kpts]
            ksymops = [[(Mat3{Int}(I), Vec3(zeros(3)))] for _ in 1:length(kcoords)]
        end

        # Convert ecut to Hartree
        Ecut = self.parameters["ecut"] / ase_units.Hartree
        if isnothing(kgrid)
            PlaneWaveBasis(model, Ecut, kcoords, ksymops)
        else
            PlaneWaveBasis(model, Ecut, kgrid=kgrid, kshift=kshift)
        end
    end

    function get_dftk_mixing(self; basis=self.get_dftk_basis())
        mixing = basis.model.temperature > 0 ? KerkerMixing(0.7, 1.0) : SimpleMixing(0.7)
        if !isnothing(self.parameters["mixing"])
            if self.parameters["mixing"] isa Tuple
                name = self.parameters["mixing"][1]
                args = ifelse(length(self.parameters["mixing"]) < 2, (),
                              self.parameters["mixing"][2:end])
            else
                name = self.parameters["mixing"]
                args = ()
            end

            valid_types = Dict("KerkerMixing" => KerkerMixing,
                               "SimpleMixing" => SimpleMixing)
            if !haskey(valid_types, name)
                inputerror("A mixing method $name is not known to DFTK.")
            else
                mixing = valid_types[name](args...)
            end
        end
        mixing
    end

    function get_dftk_scfres(self; basis=self.get_dftk_basis())
        mixing = self.get_dftk_mixing(basis=basis)

        extraargs=()
        if !isnothing(self.parameters["nbands"])
            extraargs = (n_bands=self.parameters["nbands"], )
        end

        callback = info -> ()
        if self.parameters["verbose"]
            callback = scf_default_callback
        end

        try
            tol = self.parameters["scftol"]  # TODO Maybe unit conversion here!
            self_consistent_field(basis; tol=tol, callback=callback,
                                  mixing=mixing, extraargs...)
        catch e
            pyraise(calculator.SCFError(string(e)))
        end
    end

    function calculate(self, atoms=nothing, properties=["energy"],
                       system_changes=calculator.all_changes)
        calculator.Calculator.calculate(self, atoms=atoms, properties=properties,
                                        system_changes=system_changes)
        results = self.results  # Load old results

        # Run the SCF and update the energy
        scfres = isnothing(self.scfres) ? self.get_dftk_scfres() : self.scfres
        results["energy"] = sum(values(scfres.energies)) * ase_units.Hartree

        # Compute forces, if requested:
        if "forces" in properties
            # TODO If the calculation fails, ASE expects an
            #      calculator.CalculationFailed exception
            fvalues = hcat((Array(d) for fatom in forces(scfres) for d in fatom)...)'
            results["forces"] = fvalues * (ase_units.Hartree / ase_units.Bohr)
        end

        # Commit results and dump them to disk:
        self.results = results
        self.scfres = scfres
        self.write()
    end
end

end

using JSON
using DFTK
using JLD2
using MPI
using Unitful
using UnitfulAtomic

function setup()
    if DFTK.mpi_nprocs() > 1
        DFTK.disable_threading()
    else
        DFTK.setup_threading()
    end
    DFTK.mpi_master() || (redirect_stdout(); redirect_stderr())
end

inputerror(parameters, p) = error("Unknown value to parameter $p: $(get(parameters, p, ""))")


function get_dftk_model(parameters, extra)
    # Parse psp and DFT functional parameters
    functionals = [:lda_xc_teter93]
    if lowercase(parameters["xc"]) == "lda"
        psp_functional = "lda"
        functionals = [:lda_xc_teter93]
    elseif lowercase(parameters["xc"]) == "pbe"
        psp_functional = "pbe"
        functionals = [:gga_x_pbe, :gga_c_pbe]
    else
        inputerror(parameters, "xc")
    end

    if !isnothing(parameters["functionals"])
        funs = parameters["functionals"]
        if funs isa AbstractArray
            functionals = Symbol.(funs)
        else
            functionals = [Symbol(funs)]
        end
    end

    if parameters["pps"] == "hgh"
        psp_family = "hgh"
        psp_core = :fullcore
    elseif parameters["pps"] == "hgh.k"
        psp_family = "hgh"
        psp_core = :semicore
    else
        inputerror(parameters, "pps")
    end

    # Parse smearing and temperature
    temperature = 0.0u"eV"
    smearing = nothing
    if !isnothing(parameters["smearing"])
        psmear = parameters["smearing"]
        if lowercase(psmear[1]) == "fermi-dirac"
            smearing = Smearing.FermiDirac()
        elseif lowercase(psmear[1]) == "gaussian"
            smearing = Smearing.Gaussian()
        elseif lowercase(psmear[1]) == "methfessel-paxton"
            smearing = Smearing.MethfesselPaxton(psmear[3])
        else
            inputerror(parameters, "smearing")
        end
        temperature = convert(Float64, psmear[2]) * u"eV"
    end

    if parameters["charge"] != 0.0
        error("Charged systems not supported in DFTK.")
    end

    # TODO This is the place where spin-polarization should be added
    #      once it is in DFTK.

    # Build DFTK atoms
    psploader(symbol) = load_psp(symbol, functional=psp_functional,
                                 family=psp_family, core=psp_core)
    atoms = [ElementPsp(element.symbol, psp=psploader(element.symbol)) => positions
             for (element, positions) in extra["atoms"]]

    model_DFT(extra["lattice"], atoms, functionals; temperature=temperature,
              smearing=smearing)
end


function get_dftk_basis(parameters, extra; model=get_dftk_model(parameters, extra))
    # Build kpoint mesh
    kpts = parameters["kpts"]
    kgrid = [1, 1, 1]
    kshift = [0, 0, 0]
    if kpts isa Number
        # DFTK uses k-point spacing whereas ASE uses k-point density
        kgrid = kgrid_size_from_minimal_spacing(model.lattice, 1 / kpts / u"Å")
    elseif length(kpts) == 3 && all(kpt isa Number for kpt in kpts)
        kgrid = kpts  # Just a plain MP grid
    elseif length(kpts) == 4 && all(kpt isa Number for kpt in kpts[1:3])
        kpts[4] != "gamma" && error("Unknown value to kpts: $kpts")
        kgrid = kpts[1:3]
        kshift = Int.(iseven.(kgrid)) .// 2  # Shift MP grid to always contain Gamma
    elseif kpts isa AbstractArray
        kgrid = nothing
        kshift = nothing
        kcoords = [Vec3(kpt...) for kpt in kpts]
        ksymops = [[(Mat3{Int}(I), Vec3(zeros(3)))] for _ in 1:length(kcoords)]
    end

    # Convert ecut to Hartree
    Ecut = parameters["ecut"] * u"eV"
    if isnothing(kgrid)
        PlaneWaveBasis(model, austrip(Ecut), kcoords, ksymops)
    else
        PlaneWaveBasis(model, Ecut, kgrid=kgrid, kshift=kshift)
    end
end


function get_dftk_mixing(parameters, extra; basis=get_dftk_basis(parameters, extra))
    if isnothing(parameters["mixing"])
        basis.model.temperature > 0 ? KerkerMixing() : SimpleMixing(α=0.8)
    else
        include_string(Main, parameters["mixing"], @__FILE__)
    end
end


function get_dftk_scfres(parameters, extra; basis=get_dftk_basis(parameters, extra))
    mixing = get_dftk_mixing(parameters, extra; basis=basis)

    extraargs = ()
    if !isnothing(parameters["nbands"])
        extraargs = (n_bands=parameters["nbands"], )
    end

    callback = DFTK.ScfSaveCheckpoints(extra["checkpointfile"]) ∘ DFTK.ScfDefaultCallback()
    self_consistent_field(basis; tol=parameters["scftol"], callback=callback,
                          mixing=mixing, extraargs...)
end

function parse_json_array(data::Dict)
    # Simplistic parser for ndarrays as they are stored in ASE json files
    shape, type, values = data["__ndarray__"]
    shape = reverse(Int.(shape))  # row-major -> column-major
    if type == "float64"
        reshape(Float64.(values), shape...)
    elseif type == "int64"
        reshape(Int64.(values), shape...)
    else
        error("Type not implemented: $type")
    end
end


function load_state(file)
    endswith(file, ".json") || error("State file should end in .json")

    # Read input data
    if DFTK.mpi_master()
        str = open(fp -> read(fp, String), file)
    else
        str = nothing
    end
    MPI.bcast(str, 0, MPI.COMM_WORLD)
    res = JSON.parse(str)

    # Parse atoms json
    atoms_json = JSON.parse(res["atoms"])
    if length(atoms_json["ids"]) != 1
        @warn "Only parsing last atoms object in json. Ignoring all others"
    end
    atoms_id = string(atoms_json["ids"][end])

    lattice_Ang   = parse_json_array(atoms_json[atoms_id]["cell"]["array"])
    positions_Ang = parse_json_array(atoms_json[atoms_id]["positions"])
    numbers       = parse_json_array(atoms_json[atoms_id]["numbers"])

    atoms = []
    positions_fractional = Array.(eachcol(lattice_Ang \ positions_Ang))
    for (i, pos) in enumerate(positions_fractional)
        id = findfirst(el_pos -> el_pos[1].Z == numbers[i], atoms)
        if isnothing(id)
            push!(atoms, ElementCoulomb(numbers[i]) => [pos])
        else
            push!(atoms[id][2], pos)
        end
    end

    res["extra"] = Dict{String, Any}()
    res["extra"]["lattice"]    = lattice_Ang * austrip(1u"Å")
    res["extra"]["atoms"]      = atoms
    res
end


function save_state(file, state)
    endswith(file, ".json") || error("State file should end in .json")

    # Transpose arrays inside results, such that they are written
    # in a predictable order to disk
    save_results = Dict{String, Any}()
    for (key, val) in pairs(state["results"])
        if val isa AbstractArray
            if ndims(val) == 2
                save_results[key] = Vector.(eachrow(val))
                continue
            elseif ndims(val) > 2
                error("Arrays of dimension larger 2 not supported")
            end
        end
        save_results[key] = val
    end

    save_dict = Dict(
        "parameters" => state["parameters"],
        "results"    => save_results,
        "atoms"      => state["atoms"],
        "scfres"     => state["scfres"],
    )
    if DFTK.mpi_master()
        open(file, "w") do fp
            JSON.print(fp, save_dict)
        end
    end
    save_dict
end


function run_calculation(properties::AbstractArray, statefile::AbstractString)
    state = load_state(statefile)
    @assert endswith(state["scfres"], ".scfres.jld2")
    prefix = state["scfres"][1:end-12]
    state["extra"]["checkpointfile"] = prefix * ".checkpoint.jld2"

    if !isfile(state["scfres"])
        save_scfres(state["scfres"], get_dftk_scfres(state["parameters"], state["extra"]))
    end
    scfres = load_scfres(state["scfres"])

    state["results"]["energy"] = ustrip(auconvert(u"eV", scfres.energies.total))
    if "forces" in properties
        # TODO If the calculation fails, ASE expects an
        #      calculator.CalculationFailed exception
        forces = compute_forces_cart(scfres)

        # DFTK has forces as Hartree over fractional coordinates
        # ASE wants forces as eV / Å
        n_atoms = sum(length, forces)
        cart_forces = zeros(eltype(scfres.basis), n_atoms, 3)
        for (i, atforce) in enumerate(Iterators.flatten(forces))
            cart_forces[i, :] = @. ustrip(auconvert(u"eV/Å", atforce))
        end
        state["results"]["forces"] = cart_forces
    end
    save_state(statefile, state)
end


function main()
    setup()
    run_calculation(ARGS[1:end-1], ARGS[end])
end

(abspath(PROGRAM_FILE) == @__FILE__) && main()

using Test
using JSON
using LinearAlgebra
using Unitful
using UnitfulAtomic
include("run_calculation.jl")

@testset "Basic LDA basis construction" begin
    state      = load_state("mg.json")
    parameters = Dict(state["parameters"]...,
                      "xc"   => "LDA",
                      "kpts" => [1, 2, 3],
                      "ecut" => 300)
    basis = get_dftk_basis(parameters, state["extra"])

    lattice = basis.model.lattice
    @test lattice[:, 1] ≈ austrip(1u"Å") * [3.21, 0.0, 0.0]
    @test lattice[:, 2] ≈ austrip(1u"Å") * [-1.605, 2.7799415461480477, 0.0]
    @test lattice[:, 3] ≈ austrip(1u"Å") * [0.0, 0.0, 5.21304]

    atoms = basis.model.atoms
    @test length(atoms) == 1
    @test all(at isa ElementPsp for (at, positions) in atoms)
    @test atoms[1][1].symbol == :Mg
    @test atoms[1][2][1] ≈ [0, 0, 0]
    @test atoms[1][2][2] ≈ [1/3, 2/3, 1/2] atol=1e-5
    @test atoms[1][1].psp.identifier == "hgh/lda/mg-q2.hgh"
    @test atoms[1][1].psp.Zion == 2

    @test basis.model.temperature == 0.0
    @test basis.model.smearing isa DFTK.Smearing.None
    @test basis.model.spin_polarization == :none

    xcterm = only(tt for tt in basis.model.term_types if tt isa Xc)
    @test only(xcterm.functionals) == :lda_xc_teter93

    @test length(basis.kpoints) == 4
    @test basis.Ecut ≈ 300 * austrip(1u"eV") atol=1e-8
end

@testset "PBE semicore basis construction" begin
    state      = load_state("mg.json")
    parameters = Dict(state["parameters"]...,
                      "xc"       => "PBE",
                      "kpts"     => 3.333,
                      "smearing" => ("Gaussian", 10),
                      "pps"      => "hgh.k")  # semicore psps
    basis = get_dftk_basis(parameters, state["extra"])

    atoms = basis.model.atoms
    @test length(atoms) == 1
    @test length(atoms) == 1
    @test all(at isa ElementPsp for (at, positions) in atoms)
    @test atoms[1][1].psp.identifier == "hgh/pbe/mg-q10.hgh"
    @test atoms[1][1].psp.Zion == 10

    @test basis.model.temperature ≈ 10 * austrip(1u"eV") atol=1e-8
    @test basis.model.smearing isa DFTK.Smearing.Gaussian
    @test basis.model.spin_polarization == :none

    xcterm = only(tt for tt in basis.model.term_types if tt isa Xc)
    @test length(xcterm.functionals) == 2
    @test xcterm.functionals[1] == :gga_x_pbe
    @test xcterm.functionals[2] == :gga_c_pbe

    kgrid = DFTK.kgrid_size_from_minimal_spacing(basis.model.lattice,
                                                 1 / 3.333austrip(1u"Å"))
    kcoords, ksymops = bzmesh_ir_wedge(kgrid, basis.model.symmetries)
    @test kcoords ≈ [kpt.coordinate for kpt in basis.kpoints]
end

@testset "Custom functional construction" begin
    kpts = [(0, 0, 0), (0.5, 0.7, 0.3)]
    state      = load_state("mg.json")
    parameters = Dict(state["parameters"]...,
                      "xc"       => "PBE",
                      "kpts"     => kpts,
                      "smearing" => ("Fermi-Dirac", 5))
    basis = get_dftk_basis(parameters, state["extra"])

    @test basis.model.temperature ≈ 5 * austrip(1u"eV") atol=1e-8
    @test basis.model.smearing isa DFTK.Smearing.FermiDirac
    @test basis.model.spin_polarization == :none

    xcterm = only(tt for tt in basis.model.term_types if tt isa Xc)
    @test length(xcterm.functionals) == 2
    @test xcterm.functionals[1] == :gga_x_pbe
    @test xcterm.functionals[2] == :gga_c_pbe

    @test length(basis.kpoints) == 2
    @test Float64.(basis.kpoints[1].coordinate) ≈ [kpts[1]...]
    @test Float64.(basis.kpoints[2].coordinate) ≈ [kpts[2]...]
end

@testset "Test kpoint options" begin
    kpointoptions = [
        (ase=2.0,                length=18, kpt1=[0.0, 0.0, 0.0], kpt2=[ 1/5, 0.0, 0.0]),
        (ase=[2, 3, 4],          length=12, kpt1=[0.0, 0.0, 0.0], kpt2=[-0.5, 0.0, 0.0]),
        (ase=[2, 3, 4, "gamma"], length=6,  kpt1=[1/4, 0.0, 1/8], kpt2=[ 1/4, 1/3, 1/8]),
        (ase=[(0, 0.2, 0), (0.5, 0.2, 0.3)], length=2,
         kpt1=[0, 0.2, 0], kpt2=[0.5, 0.2, 0.3]),
    ]

    for params in kpointoptions
        state      = load_state("mg.json")
        parameters = Dict(state["parameters"]..., "kpts" => params.ase)
        basis = get_dftk_basis(parameters, state["extra"])
        @test length(basis.kpoints) == params.length
        @test Float64.(basis.kpoints[1].coordinate) ≈ params.kpt1
        @test Float64.(basis.kpoints[2].coordinate) ≈ params.kpt2
    end
end

@testset "Test smearing options" begin
    smearingoptions = [
        (ase=("Fermi-Dirac", 10), temperature=10 * austrip(1u"eV"),
         smearing=DFTK.Smearing.FermiDirac),
        (ase=("Gaussian", 5), temperature=5 * austrip(1u"eV"),
         smearing=DFTK.Smearing.Gaussian),
        (ase=("Methfessel-Paxton", 5, 0), temperature=5 * austrip(1u"eV"),
         smearing=DFTK.Smearing.Gaussian),
        (ase=("Methfessel-Paxton", 5, 1), temperature=5 * austrip(1u"eV"),
         smearing=DFTK.Smearing.MethfesselPaxton1),
        (ase=("Methfessel-Paxton", 5, 2), temperature=5 * austrip(1u"eV"),
         smearing=DFTK.Smearing.MethfesselPaxton2),
    ]

    for params in smearingoptions
        state      = load_state("mg.json")
        parameters = Dict(state["parameters"]..., "smearing" => params.ase)
        model = get_dftk_model(parameters, state["extra"])
        @test model.smearing isa params.smearing
        @test model.temperature ≈ params.temperature atol=1e-8
    end
end

@testset "Test mixing options" begin
    mixingoptions = [
        (ase="SimpleMixing()",               mixing=SimpleMixing, α=0.8),
        (ase="SimpleMixing(α=0.4)",          mixing=SimpleMixing, α=0.4),
        (ase="KerkerMixing(α=0.4, kTF=0.7)", mixing=KerkerMixing, α=0.4),
        (ase="KerkerMixing()",               mixing=KerkerMixing, α=0.8),
        (ase="DielectricMixing()",           mixing=DielectricMixing, α=0.8),
        (ase="DielectricMixing(α=0.2, kTF=0.7, εr=8.0)",
                                             mixing=DielectricMixing, α=0.2),
        # HybridMixing gets translated to DFTK.χ0Mixing internally
        (ase="HybridMixing()",               mixing=χ0Mixing, α=0.8),
        (ase="HybridMixing(α=0.2, kTF=0.7, εr=8.0)",
                                             mixing=χ0Mixing, α=0.2),
    ]

    for params in mixingoptions
        state      = load_state("mg.json")
        parameters = Dict(state["parameters"]..., "mixing" => params.ase)
        mixing = get_dftk_mixing(parameters, state["extra"])
        @test (mixing isa params.mixing)
        @test mixing.α == params.α
    end
end

# TODO Missing checks for mandatory ASE parameters:
#      See https://wiki.fysik.dtu.dk/ase/development/calculators.html
#      and https://wiki.fysik.dtu.dk/ase/development/proposals/calculators.html
#      - charge

@testset "Silicon calculation" begin
    label = "silicon_dftk"
    ENERGY_PBE = -213.12688268374683  # eV
    FORCES_PBE = [[0.0, 0.0, 0.0], [0.0, 0.0, 0.0]]

    state = load_state("si.json")
    state["parameters"] = Dict(state["parameters"]...,
                               "xc" => "PBE",
                               "kpts" => (3, 3, 3),
                               "ecut" => 190,
                               "scftol" => 1e-4,
                               "nbands" => 12)
    save_state(label * ".json", state)

    rm(state["scfres"], force=true)
    state = run_calculation(["energies", "forces"], label * ".json")
    @test state["results"]["energy"] ≈ ENERGY_PBE atol=1e-4 rtol=1e-4
    @test state["results"]["forces"] ≈ FORCES_PBE atol=1e-2

    orig_ene    = state["results"]["energy"]
    orig_forces = state["results"]["forces"]
    orig_atoms  = state["atoms"]

    save_state(label * ".json", state)
    state = load_state(label * ".json")

    # Check we got the old parameters and results back:
    @test state["parameters"]["xc"]   == "PBE"
    @test state["parameters"]["kpts"] == [3, 3, 3]
    @test state["parameters"]["ecut"] == 190
    @test state["results"]["energy"] ≈ orig_ene
    @test state["results"]["forces"] ≈ orig_forces
    @test state["atoms"] == orig_atoms
end
